import AdvancedLogger from "./AdvancedLogger";
import { TransformationEnum } from "./enums/TransformationEnum";
import ConsoleService from "./service/ConsoleService";
import ElasticsearchService from "./service/ElasticsearchService";
import LogglyService from "./service/LogglyService";
import SumologicService from "./service/SumologicService";
import InstantStrategy from "./strategy/InstantStrategy";
import OnBundleSizeStrategy from "./strategy/OnBundleSizeStrategy";
import OnIntervalStrategy from "./strategy/OnIntervalStrategy";
import OnRequestStrategy from "./strategy/OnRequestStrategy";
declare const strategy: {
    InstantStrategy: typeof InstantStrategy;
    OnBundleSizeStrategy: typeof OnBundleSizeStrategy;
    OnRequestStrategy: typeof OnRequestStrategy;
    OnIntervalStrategy: typeof OnIntervalStrategy;
};
declare const service: {
    SumologicService: typeof SumologicService;
    LogglyService: typeof LogglyService;
    ConsoleService: typeof ConsoleService;
    ElasticsearchService: typeof ElasticsearchService;
};
export { AdvancedLogger, strategy, service, TransformationEnum };
